<template>
<st-content heading="Tutor">
  <st-back-btn/>
  <st-update 
    :key="componentKey"
    :data="{ ids, fields, showInfo }"
    v-model="dialog"
    @refresh="refresh"
  />
  <v-row no-gutters>
    <v-col md="12">
      <div class="content-body">
        <div class="table-heading">
          <st-subtitle text="Datos generales"/>
          <st-edit-btn @click="open"/>
        </div>
        <v-row>
          <v-col md="6" v-for="(field,index) in fields" :key="index">
            <v-row align="center" no-gutters>
              <v-col md="4"><v-label>{{ field.label }}</v-label></v-col>
              <v-col md="8"><v-label>{{ field.value }}</v-label></v-col>
            </v-row>
          </v-col>
        </v-row>
        <v-row>
          <v-col>
            <v-label>
              <span class="text--secondary font-italic">
              {{ showInfo ? 'Tiene permiso ' : 'No tiene permiso' }} para ver información adicional del alumno
              </span>
            </v-label>
          </v-col>
        </v-row>
      </div>
    </v-col>
  </v-row>
  <v-row>
    <v-col md="12">
      <div class="content-body">
         <st-secondary-btn
          nombre="Programar Horario"
          @click="goCalendar"
        />
      </div>
    </v-col>
  </v-row>
</st-content>
</template>

<script>
import UpdateTutor from '@/components/tutor/UpdateTutor'
export default {
  data () {
    return {
      componentKey: 0,
      dialog: false,
      ids: null,
      fields:{
        correo: { label:'Correo', value: '...Cargando' },
        codigo: { label:'Código', value: '...Cargando' },
        nombres: { label:'Nombres', value: '...Cargando' },
        apellidoPat: { label:'Apellido Paterno', value: '...Cargando' },
        apellidoMat: { label:'Apellido Materno', value: '...Cargando' },
        telefono: { label:'Teléfono', value: '...Cargando' },
      },
      showInfo: null
    }
  },
  mounted(){
    this.getInfo()
  },
  components:{
    'st-update': UpdateTutor
  },
  methods: {
    open(){
      this.dialog = true
      this.componentKey += 1; //forceRerender
    },
    refresh(value){
      this.dialog = false
      this.getInfo()
    },
    async getInfo(){
      try{
        let { data: { data } } = await this.$api.getTutor(this.$route.params.id)
        let { idTutor, idUsuario, tienePermisoAccesoInfoAdicional, ...others } = data
        this.ids = { idTutor, idUsuario }
        this.showInfo = tienePermisoAccesoInfoAdicional
        for (let prop in others){
          this.fields[prop].value = others[prop] || '-'
        }
        let name = `${data.nombres} ${data.apellidoPat} ${data.apellidoMat}`
        this.$store.commit('updateName', { index: 'tutor', value: name })
      } catch (e) {
        this.$store.commit('setError', e)
      }
    },
    goCalendar(){
      let calendarPath = "/coordinador/tutor/" + this.$route.params.id + "/horario";
      this.$router.push(calendarPath)
    }
  }
}
</script>

<style scoped lang="scss">
</style>
